#include <iostream>
#include "mymatrix.h"

matrix::matrix() {
  rows = 0;
  cols = 0;
  elements = new double[0];
}

matrix::matrix(int r, int c) {
  rows = r;
  cols = c;
  elements = new double[rows*cols];
  if (elements==0)
    std::cerr << "Error: could not allocate memory\n";
}

matrix::matrix(matrix& m) {
  rows = m.rows;
  cols = m.cols;
  elements = new double[rows*cols];
  for (int i=0; i < rows*cols; i++)
    elements[i] = m.elements[i];
}

matrix& matrix::operator=(matrix& m) {
  if (&m != this) {
    delete[] elements;
    rows = m.rows;
    cols = m.cols;
    elements = new double[rows*cols];
    for (int i=0; i<rows*cols; i++)
      elements[i] = m.elements[i];
  }
  return *this;
}

matrix::~matrix() {
  rows = 0;
  cols = 0;
  delete[] elements;
}

int matrix::get_rows() {
  return rows;
}

int matrix::get_cols() {
  return cols;
}

double& matrix::element(int i, int j) {
  return elements[i*cols + j];
}

void matrix::fill(double value) {
  for (int i=0; i < rows; i++) 
    for (int j=0; j < cols; j++) 
      element(i,j)=value;
}

