#ifndef _MYMATRIXH_
#define _MYMATRIXH_
class matrix {
  //private:
protected:
  int rows, cols;
  double* elements;
public:
  matrix();
  matrix(int r, int c);
  matrix(matrix& m);
  matrix& operator=(matrix& m);
  ~matrix();
  int get_rows();
  int get_cols();
  // Add virtual for pointers 
  virtual void fill(double value);

  double& operator() (int i, int j);
};
std::ostream& operator<<(std::ostream& o, matrix& m);
#endif


// Inheritance example
class squarematrix : public matrix {
private:
protected:
public:
  
   squarematrix(int r, int c): matrix(r,c){ 
     if(r!=c){ std::cerr<<"not a square matrix\n"; exit(1); }
   }

  double trace(){ 
    double sum(0.0);
    for(int i=0; i <rows ; i++)
      sum += elements[i*cols+i];
    return sum;
  }

  void fill(double value){
    std::cout<<"\n Filling using squarematrix \n";
    for (int i=0; i < rows*cols; i++) 
      elements[i] = value;
  }


};

